#include <string.h>
#include <time.h>
#include <stdlib.h>

#include "cdi.h"

static char *ghistory = NULL;
static size_t ghistorysize = 0;

static char strtime[32];

static
void init_strtime()
{
  time_t tp;
  struct tm *ltime;

  tp = time(NULL);

  if ( tp != -1 )
    {
      ltime = localtime(&tp);
      (void) strftime(strtime, sizeof(strtime), "%a %b %d %H:%M:%S %Y: ", ltime);
    }
}

static
char *get_strtimeptr()
{
  if ( strlen(strtime) == 0 )
    init_strtime();

  return (strtime);
}

void afterInqHistory(int fileID)
{
  if ( ghistory )
    {
      free(ghistory);
      ghistorysize = 0;
      ghistory = NULL;
    }

  ghistorysize = streamInqHistorySize(fileID);
  if ( ghistorysize > 0 )
    {
      size_t len;
      ghistory = (char *) malloc(ghistorysize+1);
      ghistory[ghistorysize] = 0;
      streamInqHistoryString(fileID, ghistory);
      len = strlen(ghistory);
      if ( len < ghistorysize )
	{
	  /* printf("%d %d\n", len, ghistorysize); */
	  ghistorysize = len;
	}
    }
}


void afterDefHistory(int fileID, char *histstring)
{
  char *history = NULL;
  size_t historysize = 0;
  char *strtimeptr;
  int strtimelen;

  strtimeptr = get_strtimeptr();
  strtimelen = strlen(strtimeptr);
  
  historysize = ghistorysize+1+strtimelen+strlen(histstring)+1;
  history = (char *) malloc(historysize);
  history[0] = 0;

  strcpy(history, strtimeptr);
  strcat(history, histstring);
 
  if ( ghistory )
    {
      strcat(history, "\n");
      strcat(history, ghistory);
    }

  streamDefHistory(fileID, strlen(history), history);
  free(history);
}
